function[Y]=RK4(Y0,t0,deltat,tn,n,d,lamda,tau,delta,gamma,sigma)
%inputs:
%   Y0 = initial column vector of concentrations (length 2n)
%   t0 = initial time
%   deltat = step size
%   tn = final time
%   n = number of nuclei
%   d,lambda,tau,delta,gamma,sigma = model parameters


t=t0:deltat:tn;

   for i=1:n
        S(i)=sigma;
   end;
   for i=n+1:2*n
        S(i)=0;
   end;

Y(1,:)=Y0';
for i=2:length(t)
    m(i-1,:)=model(Y(i-1,:),n,d,lamda,tau,delta,gamma,S);
    r(i-1,:)=model(Y(i-1,:)+m(i-1,:)*(deltat/2),n,d,lamda,tau,delta,gamma,S);
    q(i-1,:)=model(Y(i-1,:)+r(i-1,:)*(deltat/2),n,d,lamda,tau,delta,gamma,S;
    p(i-1,:)=model(Y(i-1,:)+q(i-1,:)*deltat,n,d,lamda,tau,delta,gamma,S);
    Y(i,:)=Y(i-1,:)+deltat*((m(i-1,:)+2*r(i-1,:)+2*q(i-1,:)+p(i-1,:))*(1/6));
end;
